
_I2C_LCD_Cmd:

;I2C LCD.c,27 :: 		void I2C_LCD_Cmd(char out_char) {
;I2C LCD.c,30 :: 		char rs = 0x00;
; rs start address is: 17 (R17)
	LDI        R17, 0
;I2C LCD.c,32 :: 		hi_n = out_char & 0xF0;
	MOV        R16, R2
	ANDI       R16, 240
; hi_n start address is: 18 (R18)
	MOV        R18, R16
;I2C LCD.c,33 :: 		lo_n = (out_char << 4) & 0xF0;
	MOV        R16, R2
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	ANDI       R16, 240
; lo_n start address is: 19 (R19)
	MOV        R19, R16
;I2C LCD.c,35 :: 		TWI_Start();
	CALL       _TWI_Start+0
;I2C LCD.c,36 :: 		TWI_Write(LCD_ADDR);
	PUSH       R2
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;I2C LCD.c,37 :: 		TWI_Write(hi_n | rs | 0x04 | 0x08);
	MOV        R16, R18
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,38 :: 		Delay_us(50);
	LDI        R16, 66
L_I2C_LCD_Cmd0:
	DEC        R16
	BRNE       L_I2C_LCD_Cmd0
	NOP
	NOP
;I2C LCD.c,39 :: 		TWI_Write(hi_n | rs | 0x00 | 0x08);
	MOV        R16, R18
	OR         R16, R17
; hi_n end address is: 18 (R18)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,40 :: 		Delay_us(100);
	LDI        R16, 133
L_I2C_LCD_Cmd2:
	DEC        R16
	BRNE       L_I2C_LCD_Cmd2
	NOP
;I2C LCD.c,41 :: 		TWI_Write(lo_n | rs | 0x04 | 0x08);
	MOV        R16, R19
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,42 :: 		Delay_us(50);
	LDI        R16, 66
L_I2C_LCD_Cmd4:
	DEC        R16
	BRNE       L_I2C_LCD_Cmd4
	NOP
	NOP
;I2C LCD.c,43 :: 		TWI_Write(lo_n | rs | 0x00 | 0x08);
	MOV        R16, R19
	OR         R16, R17
; rs end address is: 17 (R17)
; lo_n end address is: 19 (R19)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
	POP        R2
;I2C LCD.c,44 :: 		TWI_stop();
	CALL       _TWI_Stop+0
;I2C LCD.c,46 :: 		if(out_char == 0x01)Delay_ms(2);
	LDI        R27, 1
	CP         R2, R27
	BREQ       L__I2C_LCD_Cmd52
	JMP        L_I2C_LCD_Cmd6
L__I2C_LCD_Cmd52:
	LDI        R17, 11
	LDI        R16, 99
L_I2C_LCD_Cmd7:
	DEC        R16
	BRNE       L_I2C_LCD_Cmd7
	DEC        R17
	BRNE       L_I2C_LCD_Cmd7
L_I2C_LCD_Cmd6:
;I2C LCD.c,47 :: 		}
L_end_I2C_LCD_Cmd:
	RET
; end of _I2C_LCD_Cmd

_I2C_LCD_Chr:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL
	IN         R29, SPH
	SBIW       R28, 1
	OUT        SPL, R28
	OUT        SPH, R29
	ADIW       R28, 1

;I2C LCD.c,49 :: 		void I2C_LCD_Chr(char row, char column, char out_char) {
;I2C LCD.c,52 :: 		char rs = 0x01;
	PUSH       R2
	LDI        R27, 1
	STD        Y+0, R27
;I2C LCD.c,54 :: 		switch(row){
	JMP        L_I2C_LCD_Chr9
;I2C LCD.c,56 :: 		case 1:
L_I2C_LCD_Chr11:
;I2C LCD.c,57 :: 		I2C_LCD_Cmd(0x80 + (column - 1));
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 128
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
;I2C LCD.c,58 :: 		break;
	JMP        L_I2C_LCD_Chr10
;I2C LCD.c,59 :: 		case 2:
L_I2C_LCD_Chr12:
;I2C LCD.c,60 :: 		I2C_LCD_Cmd(0xC0 + (column - 1));
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 64
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
;I2C LCD.c,61 :: 		break;
	JMP        L_I2C_LCD_Chr10
;I2C LCD.c,62 :: 		case 3:
L_I2C_LCD_Chr13:
;I2C LCD.c,63 :: 		I2C_LCD_Cmd(0x94 + (column - 1));
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 108
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
;I2C LCD.c,64 :: 		break;
	JMP        L_I2C_LCD_Chr10
;I2C LCD.c,65 :: 		case 4:
L_I2C_LCD_Chr14:
;I2C LCD.c,66 :: 		I2C_LCD_Cmd(0xD4 + (column - 1));
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 44
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
;I2C LCD.c,67 :: 		break;
	JMP        L_I2C_LCD_Chr10
;I2C LCD.c,68 :: 		};
L_I2C_LCD_Chr9:
	LDI        R27, 1
	CP         R2, R27
	BRNE       L__I2C_LCD_Chr54
	JMP        L_I2C_LCD_Chr11
L__I2C_LCD_Chr54:
	LDI        R27, 2
	CP         R2, R27
	BRNE       L__I2C_LCD_Chr55
	JMP        L_I2C_LCD_Chr12
L__I2C_LCD_Chr55:
	LDI        R27, 3
	CP         R2, R27
	BRNE       L__I2C_LCD_Chr56
	JMP        L_I2C_LCD_Chr13
L__I2C_LCD_Chr56:
	LDI        R27, 4
	CP         R2, R27
	BRNE       L__I2C_LCD_Chr57
	JMP        L_I2C_LCD_Chr14
L__I2C_LCD_Chr57:
L_I2C_LCD_Chr10:
;I2C LCD.c,70 :: 		hi_n = out_char & 0xF0;
	MOV        R16, R4
	ANDI       R16, 240
; hi_n start address is: 17 (R17)
	MOV        R17, R16
;I2C LCD.c,71 :: 		lo_n = (out_char << 4) & 0xF0;
	MOV        R16, R4
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	ANDI       R16, 240
; lo_n start address is: 18 (R18)
	MOV        R18, R16
;I2C LCD.c,73 :: 		TWI_Start();
	CALL       _TWI_Start+0
;I2C LCD.c,74 :: 		TWI_Write(LCD_ADDR);
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;I2C LCD.c,75 :: 		TWI_Write(hi_n | rs | 0x04 | 0x08);
	LDD        R16, Y+0
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,76 :: 		Delay_us(50);
	LDI        R16, 66
L_I2C_LCD_Chr15:
	DEC        R16
	BRNE       L_I2C_LCD_Chr15
	NOP
	NOP
;I2C LCD.c,77 :: 		TWI_Write(hi_n | rs | 0x00 | 0x08);
	LDD        R16, Y+0
	OR         R16, R17
; hi_n end address is: 17 (R17)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,78 :: 		Delay_us(100);
	LDI        R16, 133
L_I2C_LCD_Chr17:
	DEC        R16
	BRNE       L_I2C_LCD_Chr17
	NOP
;I2C LCD.c,79 :: 		TWI_Write(lo_n | rs | 0x04 | 0x08);
	LDD        R16, Y+0
	OR         R16, R18
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,80 :: 		Delay_us(50);
	LDI        R16, 66
L_I2C_LCD_Chr19:
	DEC        R16
	BRNE       L_I2C_LCD_Chr19
	NOP
	NOP
;I2C LCD.c,81 :: 		TWI_Write(lo_n | rs | 0x00 | 0x08);
	LDD        R16, Y+0
	OR         R16, R18
; lo_n end address is: 18 (R18)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,82 :: 		TWI_stop();
	CALL       _TWI_Stop+0
;I2C LCD.c,83 :: 		}
L_end_I2C_LCD_Chr:
	POP        R2
	OUT        SPL, R28
	OUT        SPH, R29
	POP        R29
	POP        R28
	RET
; end of _I2C_LCD_Chr

_I2C_LCD_Chr_Cp:

;I2C LCD.c,85 :: 		void I2C_LCD_Chr_Cp(char out_char) {
;I2C LCD.c,88 :: 		char rs = 0x01;
	PUSH       R2
; rs start address is: 17 (R17)
	LDI        R17, 1
;I2C LCD.c,90 :: 		hi_n = out_char & 0xF0;
	MOV        R16, R2
	ANDI       R16, 240
; hi_n start address is: 18 (R18)
	MOV        R18, R16
;I2C LCD.c,91 :: 		lo_n = (out_char << 4) & 0xF0;
	MOV        R16, R2
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	ANDI       R16, 240
; lo_n start address is: 19 (R19)
	MOV        R19, R16
;I2C LCD.c,93 :: 		TWI_Start();
	CALL       _TWI_Start+0
;I2C LCD.c,94 :: 		TWI_Write(LCD_ADDR);
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;I2C LCD.c,95 :: 		TWI_Write(hi_n | rs | 0x04 | 0x08);
	MOV        R16, R18
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,96 :: 		Delay_us(50);
	LDI        R16, 66
L_I2C_LCD_Chr_Cp21:
	DEC        R16
	BRNE       L_I2C_LCD_Chr_Cp21
	NOP
	NOP
;I2C LCD.c,97 :: 		TWI_Write(hi_n | rs | 0x00 | 0x08);
	MOV        R16, R18
	OR         R16, R17
; hi_n end address is: 18 (R18)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,98 :: 		Delay_us(100);
	LDI        R16, 133
L_I2C_LCD_Chr_Cp23:
	DEC        R16
	BRNE       L_I2C_LCD_Chr_Cp23
	NOP
;I2C LCD.c,99 :: 		TWI_Write(lo_n | rs | 0x04 | 0x08);
	MOV        R16, R19
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,100 :: 		Delay_us(50);
	LDI        R16, 66
L_I2C_LCD_Chr_Cp25:
	DEC        R16
	BRNE       L_I2C_LCD_Chr_Cp25
	NOP
	NOP
;I2C LCD.c,101 :: 		TWI_Write(lo_n | rs | 0x00 | 0x08);
	MOV        R16, R19
	OR         R16, R17
; rs end address is: 17 (R17)
; lo_n end address is: 19 (R19)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,102 :: 		TWI_stop();
	CALL       _TWI_Stop+0
;I2C LCD.c,103 :: 		}
L_end_I2C_LCD_Chr_Cp:
	POP        R2
	RET
; end of _I2C_LCD_Chr_Cp

_I2C_LCD_Init:

;I2C LCD.c,106 :: 		void I2C_LCD_Init() {
;I2C LCD.c,108 :: 		char rs = 0x00;
	PUSH       R2
; rs start address is: 17 (R17)
	LDI        R17, 0
;I2C LCD.c,110 :: 		TWI_Start();
	CALL       _TWI_Start+0
;I2C LCD.c,111 :: 		TWI_Write(LCD_ADDR);
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;I2C LCD.c,112 :: 		Delay_ms(30);
	PUSH       R17
	LDI        R17, 156
	LDI        R16, 215
L_I2C_LCD_Init27:
	DEC        R16
	BRNE       L_I2C_LCD_Init27
	DEC        R17
	BRNE       L_I2C_LCD_Init27
	NOP
	NOP
	POP        R17
;I2C LCD.c,114 :: 		TWI_Write(0x30 | rs | 0x04 | 0x08);
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,115 :: 		Delay_us(50);
	LDI        R16, 66
L_I2C_LCD_Init29:
	DEC        R16
	BRNE       L_I2C_LCD_Init29
	NOP
	NOP
;I2C LCD.c,116 :: 		TWI_Write(0x30 | rs | 0x00 | 0x08);
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,117 :: 		Delay_ms(10);
	PUSH       R17
	LDI        R17, 52
	LDI        R16, 242
L_I2C_LCD_Init31:
	DEC        R16
	BRNE       L_I2C_LCD_Init31
	DEC        R17
	BRNE       L_I2C_LCD_Init31
	NOP
	POP        R17
;I2C LCD.c,119 :: 		TWI_Write(0x30 | rs | 0x04 | 0x08);
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,120 :: 		Delay_us(50);
	LDI        R16, 66
L_I2C_LCD_Init33:
	DEC        R16
	BRNE       L_I2C_LCD_Init33
	NOP
	NOP
;I2C LCD.c,121 :: 		TWI_Write(0x30 | rs | 0x00 | 0x08);
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,122 :: 		Delay_ms(10);
	PUSH       R17
	LDI        R17, 52
	LDI        R16, 242
L_I2C_LCD_Init35:
	DEC        R16
	BRNE       L_I2C_LCD_Init35
	DEC        R17
	BRNE       L_I2C_LCD_Init35
	NOP
	POP        R17
;I2C LCD.c,124 :: 		TWI_Write(0x30 | rs | 0x04 | 0x08);
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,125 :: 		Delay_us(50);
	LDI        R16, 66
L_I2C_LCD_Init37:
	DEC        R16
	BRNE       L_I2C_LCD_Init37
	NOP
	NOP
;I2C LCD.c,126 :: 		TWI_Write(0x30 | rs | 0x00 | 0x08);
	MOV        R16, R17
	ORI        R16, 48
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,127 :: 		Delay_ms(10);
	PUSH       R17
	LDI        R17, 52
	LDI        R16, 242
L_I2C_LCD_Init39:
	DEC        R16
	BRNE       L_I2C_LCD_Init39
	DEC        R17
	BRNE       L_I2C_LCD_Init39
	NOP
	POP        R17
;I2C LCD.c,129 :: 		TWI_Write(0x20 | rs | 0x04 | 0x08);
	MOV        R16, R17
	ORI        R16, 32
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,130 :: 		Delay_us(50);
	LDI        R16, 66
L_I2C_LCD_Init41:
	DEC        R16
	BRNE       L_I2C_LCD_Init41
	NOP
	NOP
;I2C LCD.c,131 :: 		TWI_Write(0x20 | rs | 0x00 | 0x08);
	MOV        R16, R17
	ORI        R16, 32
; rs end address is: 17 (R17)
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;I2C LCD.c,132 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;I2C LCD.c,134 :: 		Delay_ms(10);
	LDI        R17, 52
	LDI        R16, 242
L_I2C_LCD_Init43:
	DEC        R16
	BRNE       L_I2C_LCD_Init43
	DEC        R17
	BRNE       L_I2C_LCD_Init43
	NOP
;I2C LCD.c,136 :: 		I2C_LCD_Cmd(0x28);
	LDI        R27, 40
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;I2C LCD.c,137 :: 		I2C_LCD_Cmd(0x06);
	LDI        R27, 6
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;I2C LCD.c,138 :: 		}
L_end_I2C_LCD_Init:
	POP        R2
	RET
; end of _I2C_LCD_Init

_I2C_LCD_Out:

;I2C LCD.c,140 :: 		void I2C_LCD_Out(char row, char col, char *text) {
;I2C LCD.c,141 :: 		while(*text)
L_I2C_LCD_Out45:
	MOVW       R30, R4
	LD         R16, Z
	TST        R16
	BRNE       L__I2C_LCD_Out61
	JMP        L_I2C_LCD_Out46
L__I2C_LCD_Out61:
;I2C LCD.c,142 :: 		I2C_LCD_Chr(row, col++, *text++);
	MOVW       R30, R4
	LD         R16, Z
	PUSH       R5
	PUSH       R4
	MOV        R4, R16
	CALL       _I2C_LCD_Chr+0
	POP        R4
	POP        R5
	MOV        R16, R3
	SUBI       R16, 255
	MOV        R3, R16
	MOVW       R16, R4
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R4, R16
	JMP        L_I2C_LCD_Out45
L_I2C_LCD_Out46:
;I2C LCD.c,143 :: 		}
L_end_I2C_LCD_Out:
	RET
; end of _I2C_LCD_Out

_I2C_LCD_Out_Cp:

;I2C LCD.c,145 :: 		void I2C_LCD_Out_Cp(char *text) {
;I2C LCD.c,146 :: 		while(*text)
L_I2C_LCD_Out_Cp47:
	MOVW       R30, R2
	LD         R16, Z
	TST        R16
	BRNE       L__I2C_LCD_Out_Cp63
	JMP        L_I2C_LCD_Out_Cp48
L__I2C_LCD_Out_Cp63:
;I2C LCD.c,147 :: 		I2C_LCD_Chr_Cp(*text++);
	MOVW       R30, R2
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _I2C_LCD_Chr_Cp+0
	POP        R2
	POP        R3
	MOVW       R16, R2
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R2, R16
	JMP        L_I2C_LCD_Out_Cp47
L_I2C_LCD_Out_Cp48:
;I2C LCD.c,148 :: 		}
L_end_I2C_LCD_Out_Cp:
	RET
; end of _I2C_LCD_Out_Cp

_main:
	LDI        R27, 255
	OUT        SPL, R27
	LDI        R27, 0
	OUT        SPH, R27

;I2C LCD.c,150 :: 		void main() {
;I2C LCD.c,152 :: 		DDRC = 0x00;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	LDI        R27, 0
	OUT        DDRC, R27
;I2C LCD.c,153 :: 		PORTC = 0x00;
	LDI        R27, 0
	OUT        PORTC, R27
;I2C LCD.c,155 :: 		TWI_Init(100000);
	CBI        TWSR, 0
	CBI        TWSR, 1
	LDI        R27, 12
	OUT        TWBR, R27
	CALL       _TWI_Init+0
;I2C LCD.c,157 :: 		I2C_LCD_Init();
	CALL       _I2C_LCD_Init+0
;I2C LCD.c,158 :: 		I2C_LCD_Cmd(_LCD_CURSOR_OFF);
	LDI        R27, 12
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;I2C LCD.c,159 :: 		I2C_LCD_Cmd(_LCD_CLEAR);
	LDI        R27, 1
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;I2C LCD.c,160 :: 		I2C_Lcd_Out(1,1,txt1);                 // Write text in first row
	LDI        R27, #lo_addr(_txt1+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt1+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _I2C_LCD_Out+0
;I2C LCD.c,161 :: 		I2C_Lcd_Out(2,1,txt2);                 // Write text in second row
	LDI        R27, #lo_addr(_txt2+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt2+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _I2C_LCD_Out+0
;I2C LCD.c,162 :: 		I2C_Lcd_Out(3,1,txt3);                 // Write text in third row
	LDI        R27, #lo_addr(_txt3+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt3+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 3
	MOV        R2, R27
	CALL       _I2C_LCD_Out+0
;I2C LCD.c,163 :: 		I2C_Lcd_Out(4,1,txt4);                 // Write text in fourth row
	LDI        R27, #lo_addr(_txt4+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt4+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 4
	MOV        R2, R27
	CALL       _I2C_LCD_Out+0
;I2C LCD.c,165 :: 		while(1) {
L_main49:
;I2C LCD.c,167 :: 		}
	JMP        L_main49
;I2C LCD.c,168 :: 		}
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
